routine_speed	MACRO speed_kleur
		if	routine_timers
                push    ax
                push    dx
                cli                     
                                        
                mov     dx,3DAh
                in      al,dx           
                                       
                mov     dx,3C0h        
                mov     al,31h         
                out     dx,al          
                mov     al,speed_kleur
                out     dx,al          
                sti
                pop     dx
                pop     ax
		endif
                ENDM

         .386p
         jumps

code32   segment para public use32
         assume cs:code32, ds:code32

         include ..\extern\pmode.ext
         include ..\extern\xmode.ext
         include ..\extern\kb.ext
         include ..\extern\equ.inc
         include ..\extern\macros.inc
         include ..\extern\sinustab.inc

tn_kleuren:  	include ..\data\tnlogo.col
star_kleuren:   include ..\data\ster.pal

logootje: include ..\data\tnlogo.pic


zoom_start = 512/4
zoom_stap dw 2
zoom_x	dw 0
zoom_y	dw 0
x_pos	dw 160
y_pos	dw 120
z_pos	dw zoom_start




anim_speed	dw 0
anim_teller	dw 0
anim_nummer	dd 0
anim_skull:	dw 0
		dw 36*60*1
		dw 36*60*2
		dw 36*60*3
		dw 36*60*4
		dw 36*60*5
		dw 36*60*6
		dw 36*60*7
		dw 36*60*8
		dw 36*60*7
		dw 36*60*6
		dw 36*60*5
		dw 36*60*4
		dw 36*60*3
		dw 36*60*2
		dw 36*60*1
		dw -1
plaatje2: include ..\data\ster.pic


ster_tabel:
	 include ..\extern\sterren.tab
ster_palet:
	i=64
	rept	33
	db i,i,i
	i=i-2
	endm


ster_aantal	= 80
ster_diepte	= 2000h
ster_x		= 160
ster_y		= 120
ster_z		= 255
ster_clipx	= 320-1
ster_clipy	= 240-1

ster_perspectief:	dw ster_diepte dup (0)

routine_timers = 1

        public _main
_main:
        sti
        call 	_initkb

        pushw 	4	;x_mode 320*240
        pushw 	320	;xactual
        pushw 	240	;yactual
        pushw 	2	;pages
        call 	_set_vga_modex
        cmp 	ax,-1  
        jne 	eruit

        pushw 	1		; pagina 0
        call 	_set_active_page

;	push  	offset skull_kleuren
	push  	offset star_kleuren
;	push  	offset ster_palet
;	push  	offset tn_kleuren
        pushw 	0
        pushw 	255
	pushw 	1
        call 	_load_dac_registers

;	push  	offset skull_kleuren
;	push  	offset star_kleuren
;	push  	offset ster_palet
	push  	offset tn_kleuren
        pushw 	0
        pushw 	8
	pushw 	1
        call 	_load_dac_registers

	mov	clip_links,0
	mov	clip_rechts,319
	mov	clip_boven,0
	mov	clip_onder,239



	call	ster_init

	mov	esi,offset beweeg_data
	cld
	lodsw
	mov	[beweeg_teller],ax
	mov	dword ptr [beweeg_ptr],esi

	call	bub_sort

routines:
	call	_flip_page
	routine_speed 1
	call	scherm_schoon2

	routine_speed 2
	call	beweeg_object
	
	routine_speed 254
	call	bub_sort
	routine_speed 255
	call	heelal_3d

	routine_speed 5
	call	doe_logo

	routine_speed 0

        in 	al,60h                          ; escape ingedrukt?
        cmp 	al,1
        jne 	routines
escape_los:
        in 	al,60h                          ; escape los?
        cmp 	al,1
        je 	escape_los

eruit:	call 	_resetkb	
	call 	_mode03
	jmp 	_exit

scherm_schoon2:
	out_16	3c4h,00f02h
	mov	edi,_current_page
	xor	eax,eax
	xor	ecx,ecx
	mov	cx,320*240/4/4
	cld
	rep	stosd
	ret


 even

beweeg_ptr	dd 0
beweeg_teller	dw 0

beweeg_object:
	mov	esi,dword ptr [beweeg_ptr]
	mov	ax,word ptr [esi+0]
	add	[x_add],ax
	mov	ax,word ptr [esi+2]
	add	[y_add],ax
	mov	ax,word ptr [esi+4]
	add	[z_add],ax
	mov	ax,word ptr [esi+6]
	add	[rot_ster],ax
	and	[rot_ster],1024-1

	dec	[beweeg_teller]
	jnz	einde_bteller
	add	esi,8
	mov	ax,word ptr [esi+0]
	or	ax,ax
	jns	beweeg_opnieuw
	mov	esi,offset beweeg_data
	mov	ax,word ptr [esi+0]
beweeg_opnieuw:
	mov	[beweeg_teller],ax
	add	esi,2
	mov	dword ptr [beweeg_ptr],esi
einde_bteller:
	ret

 even

beweeg_data:
;	dw    1,1,0,0,0	
;	dw    256*32,0,0,0,0	
	dw    1,0,0,100,0	
	dw    250,0,0,0,6
	dw    1,0,0,-100,0	
	dw    100,2,0,0,2
	dw    100,-1,0,0,3

	dw    100,0,-1,0,-1
	dw    250,0,0,0,-2
	dw    100,0,2,0,1
	dw    100,0,-1,0,-3

	dw    100,-1,0,0,1
	dw    100,0,0,-1,-1
	dw    250,0,0,0,4
	dw    100,0,0,2,-2
	dw    100,0,0,-1,2

	dw    10,1,0,1,2
	dw    10,-1,0,1,-6
	dw    10,-1,0,-1,-1
	dw    10,1,0,-1,1

	dw    10,0,1,1,3
	dw    10,0,-1,1,0
	dw    10,0,-1,-1,0
	dw    10,0,1,-1,0

	dw    10,1,1,0,0
	dw    10,-1,1,0,1
	dw    10,-1,-1,0,3
	dw    10,1,-1,0,-3

	dw    -1

x_add		dw 0
y_add		dw 0
z_add		dw 0
xadd_temp	dw 0
yadd_temp	dw 0
zadd_temp	dw 0
zs_sin 		dw 0
zs_cos 		dw 0
rot_ster	dw 0
z_projectie	dw 0

scherm_breedte	dw 80

heelal_3d:
	movsx	eax,[rot_ster]		;sinus & cosinus halen voor hoek z
	mov	bx,offset sinustabel[eax*2]
	mov	[zs_sin],bx
	mov	bx,offset cosinustabel[eax*2]
	mov	[zs_cos],bx

;	mov	esi,offset plaatje	;pak anim_nummer
;	xor	[anim_speed],1
;	jz	s doe_anim
;	mov	ax,[anim_teller]
;	mov	ax,offset anim_skull[eax*2]
;	mov	[anim_nummer],eax
;	cmp	ax,-1
;	jne	s anim_plaatje
;	mov	[anim_teller],0
;	mov	[anim_nummer],0
;anim_plaatje:
;	inc	[anim_teller]
;doe_anim:
;	add	esi,[anim_nummer]
;	mov	[bob_pointer],esi


	mov	esi,offset ster_tabel
	mov	edi,offset ster_perspectief
	mov	ax,[x_add]
	mov	bx,[y_add]
	mov	cx,[z_add]
	add	ax,1000h	; midden waarde
	add	bx,1000h	; midden waarde
	mov	[xadd_temp],ax
	mov	[yadd_temp],bx
	mov	[zadd_temp],cx

	mov	cx,ster_aantal
ster_loop:
	push	cx
	movsx	eax,word ptr [esi+0]	; pak coordinaten
	movsx	ebx,word ptr [esi+2]
	movsx	ecx,word ptr [esi+4]

	add	ax,[xadd_temp]		; verhogen, overloop, centreren
	and	eax,1fffh
	sub	eax,1000h
	add	bx,[yadd_temp]
	and	ebx,1fffh
	sub	ebx,1000h
	add	cx,[zadd_temp]
	and	ecx,1fffh

	mov	word ptr [esi+0],ax	; save coordinaten
	mov	word ptr [esi+2],bx
	mov	word ptr [esi+4],cx
	add	esi,6

	cmp	ecx,ster_z
	jl	volgende_ster

	call	roteer_z

	movsx	ebp,word ptr [edi+ecx*2] ; pak perspectief_waarde
	imul	eax,ebp
	sar	eax,16
	add	eax,ster_x
	imul	ebx,ebp
	sar	ebx,16
	add	ebx,ster_y

	shr 	ecx,8	
	mov	[z_projectie],cx

;	call	plot_pixel
;	call	bob_anim
	call	ster_bob

volgende_ster:
	pop	cx
	dec	cx
	jnz	ster_loop
	ret

plot_pixel:
	cmp	eax,ster_clipx
	ja	volgende_ster			; niet plotten ?
	cmp	ebx,ster_clipy
	ja	volgende_ster			; niet plotten ?
	push	edi
	mov	edi,_current_page
	xchg	ax,bx
	mul	scherm_breedte
	mov	cx,bx
	shr	bx,2
	add	bx,ax
	mov	ax,map_mask_plane1
	and	cl,plane_bits
	shl	ah,cl
	out_16	sc_index,ax
	mov	al,byte ptr [z_projectie+1]	;= kleurnummer
	mov	[edi+ebx],al
	pop	edi
	ret


bob_pointer dd 0
bob_anim:
	push	esi
	push	edi

	mov	esi,[bob_pointer]
	mov	bp,cx	; cx = schaal
	neg	bp
	add	bp,32
	mov	cx,ax
	mov	dx,bx

	mov	ax,bp	; schaal bob
	mov	bx,ax
;	shr	ax,1
	shl	bx,1

	mov	bp,ax	; centreer bob
	shr	bp,1
	sub	cx,bp
	mov	bp,bx
	shr	bp,1
	sub	dx,bp

	mov	schaal_breedte,ax
	mov	schaal_hoogte,bx
	mov	schaal_x_pos,cx
	mov	schaal_y_pos,dx

	mov	bob_breedte,36
	mov	bob_hoogte,60
	
	call	teken_bob

	pop	edi
	pop	esi
	ret

ster_bob:
	push	esi
	push	edi

;	mov	esi,[bob_pointer]
	mov	esi,offset plaatje2	;pak anim_nummer
	shr	cx,1
	mov	bp,cx	; cx = schaal
	neg	bp
	add	bp,16
	mov	cx,ax
	mov	dx,bx

	mov	ax,bp	; schaal bob
	mov	bx,ax

	mov	bp,ax	; centreer bob
	shr	bp,1
	sub	cx,bp
	mov	bp,bx
	shr	bp,1
	sub	dx,bp

	mov	schaal_breedte,ax
	mov	schaal_hoogte,bx
	mov	schaal_x_pos,cx
	mov	schaal_y_pos,dx

	mov	bob_breedte,15
	mov	bob_hoogte,15
	
	call	teken_bob

	pop	edi
	pop	esi
	ret




doe_logo:
	mov	esi,offset logootje
	mov	ax,[zoom_x]		; schaal x
	mov	bx,[zoom_y]		; schaal y
	mov	dx,320
	sub	dx,ax
	sar	dx,1
	mov	cx,dx			; centreer x
	sub	cx,160
	mov	dx,240
	sub	dx,bx
	sar	dx,1			; centreer y
	sub	dx,120

	add	cx,[x_pos]		; x_pos
	add	dx,[y_pos]		; y_pos


	mov	schaal_breedte,ax
	mov	schaal_hoogte,bx
	mov	schaal_x_pos,cx
	mov	schaal_y_pos,dx

	mov	bob_breedte,208
	mov	bob_hoogte,169
	
	call	teken_bob
	
	mov	ax,[zoom_stap]
	add 	[zoom_x],ax
	add 	[zoom_y],ax
	sub 	[z_pos],ax
	cmp 	[z_pos],0
	jge 	zoom_clip
	mov	ax,[zoom_stap]
	neg 	ax	
	mov	[zoom_stap],ax
	jmp	zoom_verder
zoom_clip:
	cmp 	[z_pos],zoom_start
	jle 	zoom_verder
	mov	ax,[zoom_stap]
	neg 	ax	
	mov	[zoom_stap],ax
zoom_verder:
	ret


clip_links	dw 0
clip_rechts	dw 0
clip_boven	dw 0
clip_onder	dw 0
clip_breedte	dw 0
clip_hoogte	dw 0
schaal_breedte	dw 0
schaal_hoogte	dw 0
schaal_x_pos	dw 0
schaal_y_pos	dw 0
bob_breedte	dw 0
bob_hoogte	dw 0
resultaat_bobx	dw 0
resultaat_boby	dw 0
bobx_teller	dd 0


teken_bob:
	cmp	schaal_breedte,2
	jl	bob_einde
	cmp	schaal_hoogte,2
	jl	bob_einde

	mov	ax,schaal_y_pos
	cmp	ax,clip_onder
	jg	bob_einde
	add 	ax,schaal_hoogte
	dec 	ax
	cmp 	ax,clip_boven
	jl	bob_einde

	mov	ax,schaal_x_pos
	mov	cx,clip_rechts
	cmp	ax,clip_rechts
	jg	bob_einde

	add	ax,schaal_breedte
	dec	ax
	cmp	ax,clip_links
	jl	bob_einde

	mov	ax,schaal_breedte
	mov	clip_breedte,ax

	add	ax,ax
	neg	ax
	mov	resultaat_bobx,ax

	mov	ax,schaal_hoogte
	mov	clip_hoogte,ax

	add	ax,ax
	neg	ax
	mov	resultaat_boby,ax

	movsx	eax,clip_boven
	mov	edx,eax
	sub	dx,schaal_y_pos
	js	s onderclip

	mov	schaal_y_pos,ax
	sub	clip_hoogte,dx
	movsx	ecx,bob_hoogte
	imul	ecx,edx
	mov	eax,ecx
	cdq
	movsx	ebx,schaal_hoogte
	idiv	ebx
	movsx	edx,bob_breedte
	imul	edx,eax
	add	esi,edx
	imul	eax,ebx
	sub	ecx,eax
	sub	ecx,ebx
	add	ecx,ecx
	mov	resultaat_boby,cx

onderclip:
	mov	ax,schaal_y_pos
	add	ax,clip_hoogte
	dec	ax
	cmp	ax,clip_onder
	jle	s geen_onderclip

	mov	ax,clip_onder
	sub	ax,schaal_y_pos
	inc	ax
	mov	clip_hoogte,ax

geen_onderclip:
	movsx	eax,clip_links
	mov	edx,eax
	sub	dx,schaal_x_pos
	js	s geen_linksclip
	mov	schaal_x_pos,ax
	sub	clip_breedte,dx
	movsx	ecx,bob_breedte
	imul	ecx,edx
	mov	eax,ecx
	cdq
	movsx	ebx,schaal_breedte
	idiv	ebx
	add	esi,eax
	imul	eax,ebx
	sub	ecx,eax
	sub	ecx,ebx
	add	ecx,ecx
	mov	resultaat_bobx,cx

geen_linksclip:
	mov	ax,schaal_x_pos
	add	ax,clip_breedte
	dec	ax
	cmp	ax,clip_rechts
	jle	s geen_rechtsclip

	mov	ax,clip_rechts
	sub	ax,schaal_x_pos
	inc	ax
	mov	clip_breedte,ax

geen_rechtsclip:
	movsx	edi,schaal_y_pos
	imul	edi,xactual/4
	movsx	eax,schaal_x_pos
	mov	cx,ax
	shr	eax,2
	add	eax,_current_page
	add	edi,eax

	mov	dx,sc_index
	mov	al,map_mask
	out	dx,al

	inc	dx
	and	cx,3
	mov	al,11h
	shl	al,cl
	out	dx,al

	xor	ecx,ecx
	mov	cx,bob_breedte
	mov	bobx_teller,ecx
	shl	bob_breedte,1

	align 4

bob_rijloop:
	push	esi
	push	edi
	push	ax
	push	bp

	mov	cx,clip_hoogte
	mov	bx,resultaat_boby
	mov	dx,bob_hoogte
	add	dx,dx
	mov	bp,schaal_hoogte
	add	bp,bp
	mov	ah,[esi]
	or	ah,ah
	jz	s transparant_loop

	align 4
kolom_loop:
	mov	[edi],ah
	dec	cx
	jz	s bob_bodem
	add	edi,xactual/4
	add	bx,dx
	js	s kolom_loop

volgende_bobrij:
	add	esi,bobx_teller
	sub	bx,bp
	jns	s volgende_bobrij
	mov	ah,[esi]
	cmp	ah,0
	jz	s transparant_loop
	jmp	s kolom_loop

bob_bodem:
	pop	bp
	pop	ax
	pop	edi
	pop	esi

	rol	al,1
	adc	edi,0
	mov 	dx,sc_data
	out	dx,al

	mov	bx,resultaat_bobx
	add	bx,bob_breedte
	js	s volgende_bobkolom2
	mov	dx,schaal_breedte
	add	dx,dx
volgende_bobkolom:
	inc	esi
	sub	bx,dx
	jns	s volgende_bobkolom
volgende_bobkolom2:
	mov	resultaat_bobx,bx
	dec	clip_breedte
	jnz	bob_rijloop
bob_einde:
	ret

	align 4
transparant_loop:
	dec	cx
	jz	s bob_bodem
	add	edi,xactual/4
	add	bx,dx
	js	s transparant_loop
	jmp	s volgende_bobrij



roteer_z:
;	sal	eax,8
;	sal	ebx,8	
;	sal	ecx,8	
	push	edi

	movsx	ebp,[zs_cos]	;cosinus
	movsx	edi,[zs_sin]	;sinus
	mov	edx,edi		;sinus copieren naar edx
	add	edi,ebp		;sinus+cosinus
	imul	edx,ebx
	imul	ebp,eax
	add	ebx,eax
	mov	eax,ebp
	sub	eax,edx
	sar	eax,16		;op de amiga heb je swap !!
	add	eax,eax	
	add	eax,eax	
	imul	ebx,edi
	sub	ebx,edx
	sub	ebx,ebp
	sar	ebx,16
	add	ebx,ebx
	add	ebx,ebx
;	sar	eax,8
;	sar	ebx,8
;	sar	ecx,8	
	pop	edi
	ret


ster_init:
	mov	edi,offset ster_perspectief
	mov	ecx,ster_z
	add	edi,ster_z
	add	edi,ster_z
	mov	ebx,7fffh*ster_z
perspectief_lp:
	mov	eax,ebx
	xor	edx,edx
	cdq
	div	ecx
	stosw
	inc	ecx
	cmp	ecx,ster_diepte
	jne	perspectief_lp
	ret

bub_sort:
	mov	esi,offset ster_tabel
	xor	ebp,ebp
	mov	eax,ster_aantal-1
sort1:	mov	ebx,eax
sort2:	mov	edx,ebx
	add	edx,ebp
	mov	ecx,edx
	shl	ecx,2
	add	ecx,edx		
	add	ecx,edx		
	mov	dx,word ptr [esi+4+ecx]
	cmp	dx,word ptr [esi+10+ecx]
	jge	s sort3
	mov	di,word ptr [esi+10+ecx]
	mov	[esi+4+ecx],di	
	mov	[esi+10+ecx],dx
	mov	edx,[esi+ecx]
	mov	edi,[esi+6+ecx]
	mov	[esi+ecx],edi
	mov	[esi+6+ecx],edx
sort3:	dec	bx
	jnz	s sort2
	inc	bp
	dec	ax
	jnz	sort1
	ret


code32  ends
        end